# MCMC


#-----------------------------------
# Exercise 1 - random walk
#-----------------------------------

N<- 100000
x<-vector(N,mode="numeric")
sig<-1
x[1]<-rnorm(1,mean=0,sd=sig)
for(t in (2:N)){
  epsilon<-rnorm(1,mean=0,sd=sig)
	xstar<-x[t-1]+ epsilon
	U<-runif(1)
	R<-exp(abs(x[t-1]) - abs(xstar))
	if(U < R){
		x[t]<-xstar
	}
	else x[t]<-x[t-1]
}


par(mfrow=c(2,1))
plot(x,type="l",xlab='t',ylab=expression(x[(t)]))
acf(x,lag.max=1000)
par(mfrow=c(1,1))

u<-seq(-10,10,0.01)
fu<-0.5*exp(-abs(u))
hist(x,freq=FALSE,ylim=range(fu))
lines(u,0.5*exp(-abs(u)))

#-----------------------------------
# Exercise 2 - independence kernel
#-----------------------------------

#-----------------------------------
# Question c
#-----------------------------------
beta0<- rgamma(1,shape=2,rate=1)
n<-50
x<-rnorm(n)
y<-x*beta0+rnorm(n)
plot(x,y)
abline(0,beta0)

#-----------------------------------
# Question b
#-----------------------------------

# Likelihood function
loglik <- function(beta,x,y){
	n<- length(x)
	return(-0.5 * sum((y-beta*x)^2) - n/2*log(2*pi))
}


N<-10000
beta<-vector(N,mode="numeric")
beta[1]<-rgamma(1,shape=2,rate=1)
for(t in (2:N)){
	beta_star<-rgamma(1,shape=2,rate=1)
	u<-runif(1)
	logR <-loglik(beta_star,x,y)-loglik(beta[t-1],x,y)
	if( log(u) < logR ){ 
		beta[t]<-beta_star
		}
	else{ 
		beta[t]<- beta[t-1]
		}
}



#-----------------------------------
# Question d
#-----------------------------------

par(mfrow=c(1,3))
plot(beta,type="l")
hist(beta)
acf(beta,lag.max=200)
par(mfrow=c(1,1))

#-----------------------------------
# Question e
#-----------------------------------
ACF<-acf(beta,lag.max=200,plot=FALSE)
k0<-ACF$lag[min(which(abs(ACF$acf)<0.01))]

D<-1000 # burn in
B<-floor((N-D)/k0)

Z<-vector(B,mode="numeric")
for(b in (1:B)) Z[b]<-mean(beta[(D+(b-1)*k0+1):(D+b*k0)])
se <- sd(Z)/sqrt(B)
print(c(mean(beta),se))

